# $Revision: 1.58 $, $Date: 2011/11/12 20:37:00 $
#
# Conditonal build:
%bcond_without	initrd		# don't build initrd version
%bcond_without	dietlibc	# build initrd version with static glibc instead of dietlibc
%bcond_without	python		# Python binding
#
%define		realname	cryptsetup
Summary:	LUKS for dm-crypt implemented in cryptsetup
Summary(pl.UTF-8):	LUKS dla dm-crypta zaimplementowany w cryptsetup
Name:		cryptsetup-luks
Version:	1.4.1
Release:	1
License:	GPL v2
Group:		Base
#Source0Download: http://code.google.com/p/cryptsetup/downloads/list
Source0:	http://cryptsetup.googlecode.com/files/%{realname}-%{version}.tar.bz2
# Source0-md5:	9253b3f29abf5c6f333eb74128b0df1c
Source1:	%{name}-initramfs-root-conf
Source2:	%{name}-initramfs-root-hook
Source3:	%{name}-initramfs-root-local-top
Source4:	%{name}-initramfs-passdev-hook
Source5:	%{name}-initramfs-README
Patch0:		%{name}-diet.patch
Patch1:		%{name}-dont-drag-more-libs.patch
URL:		http://code.google.com/p/cryptsetup/
BuildRequires:	autoconf >= 2.67
BuildRequires:	automake
BuildRequires:	device-mapper-devel >= 1.02.03
BuildRequires:	gettext-devel >= 0.15
BuildRequires:	libgcrypt-devel >= 1.1.42
BuildRequires:	libselinux-devel
BuildRequires:	libsepol-devel
BuildRequires:	libtool >= 2:2.0
BuildRequires:	libuuid-devel
BuildRequires:	popt-devel >= 1.7
%if %{with python}
BuildRequires:	python-devel >= 1:2.4
BuildRequires:	rpm-pythonprov
%endif
%if %{with initrd}
BuildRequires:	libgpg-error-static
	%if %{with dietlibc}
BuildRequires:	device-mapper-dietlibc
BuildRequires:  dietlibc-static
BuildRequires:	libgcrypt-dietlibc
BuildRequires:	libuuid-dietlibc
BuildRequires:	popt-dietlibc
	%else
BuildRequires:	device-mapper-static >= 1.02.07
BuildRequires:	libgcrypt-static >= 1.1.42
BuildRequires:	libselinux-static
BuildRequires:	libsepol-static
BuildRequires:	libuuid-static
BuildRequires:	popt-static
	%endif
%endif
Requires:	popt >= 1.7
Provides:	cryptsetup = %{version}
Obsoletes:	cryptsetup
Conflicts:	udev < 1:118-1
Conflicts:	udev-core < 1:115
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
LUKS is the upcoming standard for Linux hard disk encryption. By
providing a standard on-disk-format, it does not only facilitate
compatibility among distributions, but also provide secure management
of multiple user passwords. In contrast to existing solution, LUKS
stores all setup necessary setup information in the partition header,
enabling the user to transport or migrate his data seamlessly.

This package contains implementation of LUKS for dm-crypt implemented
in cryptsetup.

%description -l pl.UTF-8
LUKS to nadchodzący standard linuksowego szyfrowania twardego dysku.
Dostarczając standardowy format danych na dysku nie tylko ułatwia
utrzymanie kompatybilności między dystrybucjami, ale także dostarcza
bezpieczne zarządzanie wieloma hasłami użytkowników. W przeciwieństwie
do istniejącego rozwiązania LUKS przechowuje wszystkie potrzebne
informacje o konfiguracji w nagłówku partycji, pozwalając
użytkownikowi przenosić lub migrować dane w sposób przezroczysty.

Ten pakiet zawiera implementację LUKS dla dm-crytpa zaimplementowaną w
cryptsetup.

%package devel
Summary:	Header files for cryptsetup library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki cryptsetup
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	device-mapper-devel
Requires:	libgcrypt-devel >= 1.1.42
Obsoletes:	cryptsetup-devel

%description devel
Header files for cryptsetup library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki cryptsetup.

%package static
Summary:	Static cryptsetup library
Summary(pl.UTF-8):	Statyczna biblioteka cryptsetup
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Obsoletes:	cryptsetup-static

%description static
Static version of cryptsetup library.

%description static -l pl.UTF-8
Statyczna wersja biblioteki cryptsetup.

%package -n python-pycryptsetup
Summary:	Python binding for cryptsetup library
Summary(pl.UTF-8):	Wiązanie Pythona do biblioteki cryptsetup
Group:		Libraries/Python
Requires:	%{name}-libs = %{version}-%{release}
%pyrequires_eq	python-libs

%description -n python-pycryptsetup
Python binding for cryptsetup library.

%description -n python-pycryptsetup -l pl.UTF-8
Wiązanie Pythona do biblioteki cryptsetup.

%package initrd
Summary:	LUKS for dm-crypt implemented in cryptsetup - initrd version
Summary(pl.UTF-8):	LUKS dla dm-crypta zaimplementowany w cryptsetup - wersja initrd
Group:		Base
Requires:	udev-initrd >= 1:115
Conflicts:	geninitrd < 10000.10

%description initrd
This package contains implementation of LUKS for dm-crypt implemented
in cryptsetup - statically linked for initrd.

%description initrd -l pl.UTF-8
Ten pakiet zawiera implementację LUKS dla dm-crypta zaimplementowaną
w cryptsetup - wersję statycznie zlinkowaną dla initrd.

%package initramfs
Summary:	LUKS for dm-crypt implemented in cryptsetup - support scripts for initramfs-tools
Summary(pl.UTF-8):	LUKS dla dm-crypta zaimplementowany w cryptsetup - skrypty dla initramfs-tools
Group:		Base
Requires:	%{name} = %{version}-%{release}
Requires:	initramfs-tools

%description initramfs
LUKS for dm-crypt implemented in cryptsetup - support scripts
for initramfs-tools.

%description initramfs -l pl.UTF-8
LUKS dla dm-crypta zaimplementowany w cryptsetup - skrypty dla
initramfs-tools.

%prep
%setup -q -n %{realname}-%{version}
%patch0 -p1
%patch1 -p1

cp -a %{SOURCE5} README.initramfs

%{__rm} po/stamp-po

%build
%{__gettextize}
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}

%if %{with initrd}
CC="%{__cc}"
%configure \
%if %{with dietlibc}
%configure \
	CC="diet ${CC#ccache } %{rpmcppflags} %{rpmcflags} %{rpmldflags} -Os" \
	LIBS="-lcompat" \
	ac_cv_lib_popt_poptConfigFileToString=yes \
	ac_cv_lib_sepol_sepol_bool_set=no \
	ac_cv_lib_selinux_is_selinux_enabled=no \
%endif
%if "%{?configure_cache}" == "1"
	--cache-file=%{?configure_cache_file}%{!?configure_cache_file:configure}-initrd.cache \
%endif
	--disable-shared \
	--enable-static \
	--enable-static-cryptsetup \
	--disable-udev \
	--disable-nls

%{__make} -C lib

%if %{with dietlibc}
# we have to do it by hand cause libtool "know better" and forces
# static libs from /usr/lib
CC="%{__cc}"
diet ${CC#ccache } %{rpmcppflags} %{rpmcflags} %{rpmldflags} -Os -I. -I./lib -static \
	-o cryptsetup-initrd src/cryptsetup.c ./lib/.libs/libcryptsetup.a \
	-lpopt -lgcrypt -lgpg-error -ldevmapper -luuid -lcompat
%else
%{__make} -C src
mv src/cryptsetup cryptsetup-initrd
%endif

%{__make} clean
%endif

%configure \
	--enable-udev \
	--enable-static \
	%{?with_python:--enable-python}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/{conf-hooks.d,hooks,scripts/local-top}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_libdir}/libcryptsetup.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/libcryptsetup.so.*.*.*) \
	$RPM_BUILD_ROOT%{_libdir}/libcryptsetup.so

%if %{with initrd}
install -d $RPM_BUILD_ROOT%{_libdir}/initrd
install -p cryptsetup-initrd $RPM_BUILD_ROOT%{_libdir}/initrd/cryptsetup
%endif

install -p %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/conf-hooks.d/cryptsetup
install -p %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/hooks/cryptroot
install -p %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/scripts/local-top/cryptroot
install -p %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/initramfs-tools/hooks/cryptpassdev

%{?with_python:%{__rm} $RPM_BUILD_ROOT%{py_sitedir}/pycryptsetup.{la,a}}

%find_lang %{realname}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files -f %{realname}.lang
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog TODO
%attr(755,root,root) %{_sbindir}/cryptsetup
%attr(755,root,root) /%{_lib}/libcryptsetup.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libcryptsetup.so.4
%{_mandir}/man8/cryptsetup.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcryptsetup.so
%{_libdir}/libcryptsetup.la
%{_includedir}/libcryptsetup.h
%{_pkgconfigdir}/libcryptsetup.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libcryptsetup.a

%if %{with python}
%files -n python-pycryptsetup
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/pycryptsetup.so
%endif

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/initrd/cryptsetup
%endif

%files initramfs
%defattr(644,root,root,755)
%doc README.initramfs
%attr(755,root,root) %{_datadir}/initramfs-tools/conf-hooks.d/cryptsetup
%attr(755,root,root) %{_datadir}/initramfs-tools/hooks/cryptroot
%attr(755,root,root) %{_datadir}/initramfs-tools/hooks/cryptpassdev
%attr(755,root,root) %{_datadir}/initramfs-tools/scripts/local-top/cryptroot

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: cryptsetup-luks.spec,v $
Revision 1.58  2011/11/12 20:37:00  qboosh
- package python binding (as python-pycryptsetup)

Revision 1.57  2011/11/12 07:38:53  arekm
- up to 1.4.1

Revision 1.56  2011/10/30 07:29:51  qboosh
- updated to 1.4.0 (note: deprecated APIs removed, new soname)
- updated diet patch, removed obsolete pl.po-update patch

Revision 1.55  2011/05/30 16:38:26  arekm
- libgcrypt still better; back to default

Revision 1.54  2011/05/30 16:02:22  arekm
- rel 2; don't drag libs like udev when not needed; use crypto backend kernel

Revision 1.53  2011/05/28 05:41:31  qboosh
- updated to 1.3.1
- updated pl.po-update patch

Revision 1.52  2011/04/21 17:46:52  qboosh
- updated to 1.3.0
- added pl.po-update patch

Revision 1.51  2011/01/08 19:58:41  arekm
- rel 2; fix initrd build after update to 1.2.0

Revision 1.50  2011/01/01 11:18:49  qboosh
- updated to 1.2.0
- updated diet patch, removed obsolete nostatic patch

Revision 1.49  2010/08/22 19:53:22  glen
- up to 1.1.3
- improvements for ccache and configure cache

Revision 1.48  2010/06/21 09:32:38  arekm
- rel 2; dietlibc fixes

Revision 1.47  2010/06/21 06:26:44  qboosh
- pl for -initrd

Revision 1.46  2010/06/21 06:19:45  qboosh
- new URLs, updated to 1.1.2 (new soname)
- removed obsolete udev,diet patches

Revision 1.45  2009/11/25 13:14:57  w.kier
- added dietlib-static to BRs for /usr/lib/dietlibc/*/libc.a
  and for dietlib-devel in chain of requires (for diet)

Revision 1.44  2009/04/06 15:08:14  baggins
- rel 10
- proper C on geninitrd

Revision 1.43  2009/03/23 14:10:51  baggins
- unify dietlibc compile options and calls

Revision 1.42  2009/03/23 13:03:13  baggins
- Conflicts: geninitrd <= 10000.3 (geninitrd-10000.3 doesn't know _libdir/initrd)

Revision 1.41  2009/03/23 12:59:05  baggins
- put programs for initrd into common directory _libdir/initrd

Revision 1.40  2009/03/18 21:45:55  baggins
- fixed dietlibc segfault
- build initrd stuff with dietlibc

Revision 1.39  2009/03/18 21:34:34  baggins
- fix vasprintf usage in dietlibc case

Revision 1.38  2009/03/18 20:52:38  baggins
- dietlibc version does not ork (segfault on luksopen)

Revision 1.37  2009/03/18 20:44:32  baggins
- rel 9
- added dietlibc bcond
- build initrd package with dietlibc by default
- disabled selinux on initrd dietlibc

Revision 1.36  2009/02/26 15:20:23  baggins
- rel 8

Revision 1.35  2009/02/26 15:12:45  baggins
- added initramfs subpackage (NEED TESTERS)

Revision 1.34  2009/02/26 14:46:19  baggins
- ordered sources

Revision 1.33  2009/02/26 14:32:57  baggins
- added initramfs support files to package

Revision 1.32  2008/11/23 15:32:46  glen
- conflicts also udev before the -core split

Revision 1.31  2008/11/22 11:03:57  arekm
- rel 7; change to C

Revision 1.30  2008/11/22 11:00:01  arekm
- rel 6; works fine without udev-core here

Revision 1.29  2008/11/12 21:16:13  glen
- update for udev 115 with udevadm; rel 5

Revision 1.28  2008/11/10 01:55:27  glen
- initrd a bit smaller by disabling nls

Revision 1.27  2008/11/09 23:22:20  glen
- add -initrd subpackage; rel 4

Revision 1.26  2008-04-03 16:17:36  glen
- release 3

Revision 1.25  2008-03-19 23:50:03  qboosh
- libtoolize (fixes build with libtool 2.2)
- ghost soname symlink
- GPL v2 (this version text included; no version specified otherwise)

Revision 1.24  2008-03-19 10:31:50  glen
- release 2 (1 for ac)

Revision 1.23  2008-03-18 22:21:38  zawadaa
- up to 1.0.6

Revision 1.22  2008-01-08 20:30:26  qboosh
- use version macro in cryptsetup Provides

Revision 1.21  2007-11-08 23:29:52  glen
- url from manpage

Revision 1.20  2007-11-08 23:28:06  glen
- from 1.0.5 release onwards, cryptsetup-luks becomes cryptsetup,
  so, provide cryptsetup
- rel 2

Revision 1.19  2007-06-22 17:55:54  prism
- up to 1.0.5

Revision 1.18  2007/05/24 21:00:19  qboosh
- I think it was meant to be _noautoreqdep

Revision 1.17  2007/05/17 20:17:59  sparky
- _noautoreq cryptsetup, not needed with new rpm but let it stay for compatibility

Revision 1.16  2007/04/02 21:40:19  sls
- cryptsetup-luks isn't equivalent of cryptsetup

Revision 1.15  2007/02/12 21:23:52  glen
- tabs in preamble

Revision 1.14  2007/02/12 00:48:43  baggins
- converted to UTF-8

Revision 1.13  2006/10/18 12:27:54  mguevara
- 1.0.4-1 update, removed libsepol-patch, added br: libtool

Revision 1.12  2006/09/18 21:55:30  qboosh
- added BRs for dynamic version

Revision 1.11  2006/08/22 21:24:43  qboosh
- added nostatic patch and static bcond (link cryptsetup dynamically by default)

Revision 1.10  2006/06/23 10:25:23  wrobell
- ver. 1.0.3

Revision 1.9  2006/06/16 04:53:57  pluto
- release 2 for rebuild with new device-mapper soname.

Revision 1.8  2006/02/18 10:18:30  qboosh
- BR: ac,am,gt

Revision 1.7  2006/02/18 02:23:31  mguevara
- added provides cryptsetup = ver for easy cryptsetup replacement

Revision 1.6  2006/02/18 02:01:37  mguevara
- 1.0.1 rel 1 - added BR libsepol-static, %{name}-sepol.patch and
  some autoconf/automake

Revision 1.5  2005/07/25 11:26:31  blekot
- up to 1.0.1
- static package done
- more BRs

Revision 1.4  2005/05/22 18:09:48  qboosh
- pl for base, don't produce empty -static package

Revision 1.3  2005/05/21 16:33:30  wrobell
- adapterized

Revision 1.2  2005/05/21 16:07:14  wrobell
- typo

Revision 1.1  2005/05/21 16:06:17  wrobell
- based on cryptsetup.spec
